# $Id: install.py,v 1.8 2003/01/29 17:05:15 gitte Exp $
# $Source: /usr/local/cvs_root/CMFTypeFilter/Extensions/install.py,v $
__version__ = "$Revision: 1.8 $"[11:-2]

from Products.CMFCore.DirectoryView import DirectoryView, addDirectoryViews, createDirectoryView
from Products.CMFCore.utils import getToolByName, minimalpath
from Products.CMFTypeFilter import typefilter_globals
from Products.ExternalMethod import ExternalMethod
from App.Common import package_home
from os import path, listdir, stat
from cStringIO import StringIO
import string

out = StringIO()

def removeSkin(self, skinname):
    """
    Remove a skin from portal_skins
    """
    skinstool = getToolByName(self, 'portal_skins')
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if skinname in path:
            path.remove(skinname)
            path = string.join(path, ', ')
            # addSkinSelection will replace existing skins as well.
            skinstool.addSkinSelection(skin, path)
            out.write("Removed %s from %s skin\n" % (skinname, skin))

    if skinname in skinstool.objectIds():
        skinstool._delObject(skinname)
        out.write('Removed %s from the skinstool\n' % skinname)

def install(self):
    """Register CMF ToolBox with the necessary tools"""

    out.write('CMF TypeFilter Installation on %s\n' % self.id)
    out.write('======================\n\n')

    actionstool = getToolByName(self, 'portal_actions')
    skinstool = getToolByName(self, 'portal_skins')
    portalroot = getToolByName(self, 'portal_url').getPortalObject()

    # Create and register tools
    tools = {'portal_typefilter':'CMF Type Filter'}

    for tool in tools.keys():
        if not tool in portalroot.objectIds():
            portalroot.manage_addProduct['CMFTypeFilter'].manage_addTool(tools[tool], None)
            out.write('Created %s\n' % tools[tool])
        else:
            out.write('%s already exists\n' % tools[tool])

    ap = actionstool.listActionProviders()
    for tool in tools.keys():
        if (type(ap) is not type([]) and type(ap) is not type(())) or not tool in ap:
            try:
                actionstool.addActionProvider(tool)
                out.write('Added %s as action provider\n' % tools[tool])
            except:
                out.write('Failed adding %s as action provider\n' % tools[tool])
        else:
            out.write('%s already existed as action provider\n' % tools[tool])
    
    
    # Setup the skins
    skinname = 'typefilter_skins'
    if skinname not in skinstool.objectIds():
        # We need to add Filesystem Directory Views for any directories
        # in our skins/ directory.  These directories should already be
        # configured.
        fp = minimalpath("%s/zpt_skins" % package_home(typefilter_globals))
        createDirectoryView(skinstool, fp, skinname)
        out.write("Added %s directory view to portal_skins\n" % fp)
    else:
        out.write("%s directory view already existed in portal_skins\n" % skinname)


    # Now we need to go through the skin configurations and insert
    # 'pim_skins' into the configurations.  Preferably, this
    # should be right before where 'content' is placed.  Otherwise, we
    # append it to the end.
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if skinname not in path:
            try: path.insert(path.index('mmm_skins') + 1, skinname)
            except ValueError:
                try:
                    path.insert(path.index('custom') + 1, skinname)
                except ValueError:
                    path.append(skinname)

            path = string.join(path, ', ')
            # addSkinSelection will replace existing skins as well.
            skinstool.addSkinSelection(skin, path)
            out.write("Added %s to %s skin\n" % (skinname, skin))
        else:
            out.write("Skipping %s skin, %s is already set up\n" % (skin,skinname))

    return out.getvalue()

def uninstall(self):
    """
    Remove skins, types and special objects
    """
    out.write('CMF Type Filter Un-Installation\n')
    out.write('===========================\n\n')
    portalroot = getToolByName(self, 'portal_url').getPortalObject()

    removeSkin(self, 'typefilter_skins')

    if 'portal_typefilter' in portalroot.objectIds():
        portalroot._delObject('portal_typefilter')
        out.write('Removed Type Filter Tool\n')

    return out.getvalue()
